PROGRAM TStrTEXT;
{ RESULTS
  This program test the StrTEXT device driver. }

{ PROGRAMMER:  ADH ==> Adolfo Di Mare }

{ USAGE
  It's best to execute this program from the IDE to
  see each variable change blow-by-blow. }

USES
  Crt, Dos,
  StrTEXT;

CONST
  CR = CHAR(13);
  LF = CHAR(10);

VAR
  F : TEXT;   { text file used for input/output }
  s : STRING; { string variable }

  ch: CHAR;
  q : ARRAY[1..SizeOf(s)] OF CHAR ABSOLUTE s;
  t : STRING;
BEGIN { TStrTEXT }

  WriteLn;
  WriteLn('---------------');

  s := 'Value';             { s = 'Value' }

  StrTEXT.AssignStr(F, s);  { init StrTEXT device }

  { now input/output on "F" goes into "s" }

  { writes 'Value' in OUTPUT }
  Reset(F);
  WHILE NOT Eof(F) DO BEGIN
    Read (F,      ch);      { input comes from "s" }
    Write(OUTPUT, ch);
  END;                    { reads 5 chars: 'Value' }

  Write(' ',ch);
  IF Eof(f) THEN BEGIN
    Read(F, ch);
    Write('.',ch);
  END;

  ReWrite(F);               { s becomes empty  }

  Write(F, '=', PI:7:5);   { s = '=3.14159'  }

  Flush(F);                 { nothing changes  }

  Write(F,'!');             { s = '=3.14159!' }

  Close(F);                 { s = '=3.14159!' }

  ReWrite(F);  { s becomes empty }

  WriteLn;
  WriteLn(   '=', PI:7:5);
  WriteLn(F, '=', PI:7:5); { s := '=3.14159'+CR+LF  }

  IF s <> '=3.14159'+CR+LF THEN BEGIN
    System.HALT;
  END;

  Write(F, 'EOF');

  Close(F);   { s remains unchanded }

  Append(F);  { s remains unchanded }

  IF s <> '=3.14159'+CR+LF+'EOF' THEN BEGIN
    System.HALT;
  END;

  Write(F, '!!!');

  IF s <> '=3.14159'+CR+LF+'EOF'+'!!!' THEN BEGIN
    System.HALT;
  END;

  WriteLn(s);

  Close(F);   { s maintains its value }

  { writes "s" in OUTPUT }
  Reset(F);
  WHILE NOT Eof(F) DO BEGIN
    Read (F,      ch);      { input comes from "s" }
    Write(OUTPUT, ch);
  END;

  IF s <> '=3.14159'+CR+LF+'EOF'+'!!!' THEN BEGIN
    System.HALT;
  END;

  IF NOT Eof(f) THEN BEGIN
    System.HALT;
  END;

  Reset(F);

  ReadLn(F,t);
  IF t <> '=3.14159' THEN BEGIN
    System.HALT;
  END;

  ReadLn(F,t);
  IF t <> 'EOF'+'!!!' THEN BEGIN
    System.HALT;
  END;

END.  { TStrTEXT }
