{ UseTest.pas  v2.0  Copyright 5/1994 Adolfo Di Mare }

{$I ADT-ADH.inc}

PROGRAM UseTest;
{ RESULTADO
  Utiliza la unidad Test.pas para dar  un ejemplo sencillo
  del manejo del men principal de un programa. Se utiliza
  como ejemplo una pequea aplicacin que permite observar
  como es que trabaja la unidad antes mencionada. }
{ PROGRAMADOR
  Adolfo Di Mare
  Gustavo Alonso Sanabria }

USES
  Crt, Test;

VAR
  GLOBAL : RECORD { contiene las variables globales }
    a,            { que se usan en las opciones     }
    b : INTEGER;
  END;

{$F+} { fuerza para llamados lejanos activada }

{$IFOPT F-}
  ERROR: Todos los procedimientos que corresponden a
         cada una de las opciones del men principal
         deben ser compilados usando llamados lejanos.
{$ENDIF}

PROCEDURE Welcome;
{ RESULATDO
  Pantalla inicial que presenta el programa }
BEGIN { Welcome }
  ClrScr;
  WriteXY(10,10, 'El siguiente el un ejemplo sencillo de como');
  WriteXY(10,11, 'utilizar  la unidad Test.pas para el manejo');
  WriteXY(10,12, 'y prueba de programas  que incluyen un men');
  WriteXY(10,15, 'Presione cualquier tecla o espere 5 segundos');

  Test.KeyDelay(5);
END;  { Welcome }

PROCEDURE GoodBye;
{ RESULTADO
  Despide el programa }
BEGIN { GoodBye; }
  ClrScr;

  { este rotulote sirve para indicar que ha habido errores }
  BOOM(10,5);

  WriteXY(10,15, 'Esto ha sido todo...' );
  WriteXY(10,16, '- Si a bien lo tiene, puede sugerirnos');
  WriteXY(10,17, '  cmo mejorar la unidad Test.pas');
  WriteXY(10,20, 'Atentamente');
  WriteXY(10,21, 'Adolfo Di Mare');
  WriteXY(10,22, 'Gustavo Alonso Sanabria');


  KeyDelay(5);
END;  { GoodBye; }

PROCEDURE Before_Menu;
{ RESULTADO
  Despliega el valor actual de GLOBAL. }
BEGIN { Before_Menu }
  ClrScr;
  Write(
    'GLOBAL (a,b) = (',
    Test.Add_Commas(GLOBAL.a), '|',
    Test.Add_Commas(GLOBAL.b), ')');
END;  { Before_Menu }

PROCEDURE After_Menu;
{ RESULTADO
  Avisa que se ha salido del men. }
BEGIN { After_Menu }

  WriteXY(5,23, 'GLOBAL (a|b) = (');
  Write(
    Add_Commas(GLOBAL.a), '|',
    Add_Commas(GLOBAL.b),')');
  WriteXY(5,24,
    'Salida de la opcin: '+
    '==> Presione cualquier tecla');

{ Acostumbramos siempre invocar a Test.KeyDelay()
  antes de retornar al men principal, para que el
  operador del programa tenga tiempo de leer la
  pantalla. }

  KeyDelay(3);
END;  { After_Menu }

PROCEDURE ReadInts;
{ RESULTADO
  Lee los dos nmeros enteros sobre los que el
  programa actuar. }
BEGIN { ReadInts }
  IF Display THEN BEGIN
    Say('Lee los dos nmeros');
  END
  ELSE BEGIN

{ Una forma de programar cada una de las opciones
  del men principal es NO usar EXIT despus de
  invocar a Test.Say(), como se muestra a
  continuacin.
  - El inconveniente de esta forma de programar
    es que todo el cdigo debe quedar indentado }

    ClrScr;
    Write('Digite el primer nmero: ');
    ReadLn(GLOBAL.a);
    Write('Digite el segundo nmero: ');
    ReadLn(GLOBAL.b);
  END;
END;  { ReadInts }

PROCEDURE InitInts;
{ RESULTADO
  Inicializa dos nmeros enteros sobre los que el
  programa actuar. }
VAR
  s,t   : STRING;
CONST
  NA = 100;
  NB =  10;
BEGIN { InitInts }

  IF Display THEN BEGIN
    System.Str(NA:1, t);
    s := 'Inicializa a = '+ t + ' b = ';
    System.Str(NB:1, t);
    s := s + t;
    Say(s);
    EXIT;
  END;

{ La otra forma de programar cada una de las opciones
  del men principal es usar EXIT despus de invocar
  a Test.Say(), como se muestra a continuacin.
  - Esta es la que acostumbramos usar siempre. }

  ClrScr;

  GLOBAL.a := NA;
  GLOBAL.b := NB;
END;  { InitInts }

PROCEDURE AddInts;
{ RESULTADO
  Lee dos nmeros enteros y los suma. }
BEGIN { AddInts }
  IF Display THEN BEGIN
    Say('Sumar dos nmeros enteros');
    EXIT;
  END;

  ClrScr;
  WriteLn(
    'El resultado de la suma es: ',
    Test.Add_Commas(GLOBAL.a + GLOBAL.b ):1);
END;  { AddInts }

PROCEDURE SubInts;
{ RESULTADO
  Lee dos nmero enteros y los resta. }
BEGIN { SubInts }
  IF Display THEN BEGIN
    Say('Restar dos enteros');
    EXIT;
  END;

  ClrScr;
  WriteLn(
    'El resultado de la resta es: ',
    Add_Commas(GLOBAL.a - GLOBAL.b ):1);
END;  { SubInts }

PROCEDURE MultInts;
{ RESULTADO
  Lee dos nmero reales y los multiplica }
BEGIN { MultInts }
  IF Display THEN BEGIN
    Say('Multiplicar dos enteros');
    EXIT;
  END;

  ClrScr;
  WriteLn(
    'El resultado de la multiplicacin es: ',
    Add_Commas(GLOBAL.a * GLOBAL.b ):1);
END;  { MultInts }

PROCEDURE DivReals;
{ RESULTADO
  Lee dos nmeros reales y los divide. }
VAR
  x, y : REAL;
BEGIN { DivReals }
  IF Display THEN BEGIN
    Say('Dividir dos reales');
    EXIT;
  END;

  ClrScr;
  IF GLOBAL.b = 0 THEN BEGIN
    WriteLn(
      'ERROR: DIVISION POR CERO');
  END
  ELSE BEGIN
    WriteLn(
      'El resultado de la divisin es: ',
      Add_Commas(GLOBAL.a DIV GLOBAL.b ):1);
  END;


END;  { DivReals }

PROCEDURE ConcatStr;
{ RESULTADO
  Lee tres tiras de caracteres y las concatena. }
VAR
  str1, str2, str3, str4 : STRING;
BEGIN { ConcatStr }
  IF Display THEN BEGIN
    Say('Concatenar tres hileras');
    EXIT;
  END;

  ClrScr;
  Write('Digite la primera tira: ');
  ReadLn(str1);
  Write('Digite la segunda tira: ');
  ReadLn(str2);
  Write('Digite la tercera tira: ');
  ReadLn(str3);
  str4 := Concat(str1, str2, str3);
  WriteLn;
  WriteLn('Las tres tiras concatenadas son: ',str4);
END;  { ConcatStr }

{$F-} { fuerza para llamados lejanos activada }

BEGIN { UseTest }
{ Le informa a Test.pas cul es el procedimiento
  que se ejecuta una sla vez al comenzar el programa,
  y antes de presentar el men principal }
  Test.First_Proc(Welcome);

{ Define cul procedimiento se ejecuatar antes de
  presentar el men principal del programa }
  Test.Pre_Menu(Before_Menu);

{ Define cul procedimiento se ejecutar inmediatamente
  despus de que se sale de alguna de las opciones del
  men principal del programa }
  Test.Post_Menu(After_Menu);

{ Define cul procedimiento se ejecutar cuando termine
  de ejecutarse el programa. }
  Last_Proc(GoodBye);

{ Define el rtulo del men principal }
  Test.Title('Men principal del programa', 7, Sngl_Line);

{ Agrega cada una de las opciones que aparecern en el
  men del programa:
  - El orden en que se invoca a Test.Add_Option()
    determina el orden en que aparecern las
    opciones en el men. }

  Add_Option(InitInts);   { Opcin A }
  Add_Option(ReadInts);   { Opcin B }
  Add_Option(AddInts);    { Opcin C }
  Add_Option(SubInts);    { Opcin D }
  Add_Option(MultInts);   { Opcin E }
  Add_Option(DivReals);   { Opcin F }
  Add_Option(ConcatStr);  { Opcin G }


{ Al depurar un ADT a veces es conveniente que Test.pas
  fuerce la ejecucin de alguna de las opciones del men
  principal. Para esto se usa el procedimiento
  Force_Option(PROC,n), que hace que el procedimiento
  "PROC" se ejecute "n" veces antes de desplegar el
  men principal }

{ fuerza que se sumen dos enteros, 2 veces }
{ Force_Option(AddInts, 2); }

{ Invoca al procemiento de la unidad Test.pas que se encarga
  de desplegar el men principal del programa, y de ejecutar
  las opciones seleccionadas por el operador. }

  Test.GoWork;


END.  { UseTest }

{ EOF: UseTest.pas }
