{ ADT-ADH.inc       Copyright 5/94    Adolfo Di Mare }

{ RESULTADO
  Este archivo contiene todas las definiciones de 
  variables de compilacin para los ADTs de Adolfo.

  - Como hay tantos ADTs, y como todos usan 
    bsicamente las mismas definiciones, es lgico 
    ponerlas todas en un archivo que se incluya en las 
    cada una de las unidades por medio de la directiva 
    de compilacin $I.

  - Lo raro es que Adolfo se haya tomado cuatro aos 
    para crear este archivo de definiciones: Ojal 
    alguien hubiera sugerido usar este (rudimentario) 
    truco antes! }

{ NOTA
  Todos los identificadores que Adolfo usa estn en 
  lengua Inglesa por las siguientes razones:

  - Los identificadores en Ingls casi siempre son ms 
    cortos.

  - Es mucho ms fcil nombrar procedimientos en 
    Ingls que en Espaol, pues en Espaol muchas 
    veces es necesario calificar los verbos que se 
    usan para nombrar procedimientos con palabras que 
    eliminan las ambiguedades. Por ejemplo, la 
    traduccin exacta de DISPOSE() es 
    Retorne_Memoria_Dinmica(), que es largo, feo, 
    incmodo y muy muy largo.

  - En general, en Ingls se pueden expresar las ideas 
    tcnicas con menos palabras. Para muestra un 
    botn: compare estos prrafos con su traduccin al 
    Ingls.

  - En esta poca de globalizacin, el Ingls es la 
    lengua oficial de la computacin, por lo que al 
    usar este lenguaje todo este trabajo, incluidos 
    los fuentes de los programas, resulta ms 
    acequible para ms personas.

  - Como la literatura de avanzada en Computacin est
    primordialmente en Ingls, para el lector es ms
    sencillo reconocor los acrnimos en Ingls. Por
    ejemplo, OOP es el trmino que siempre se usa al
    nombrar la Programacin por Objetos, por lo que el
    acrnimo POO no est a tono con la literatura
    existente. }


{ RESULTS
  This include file contains all the compiler
  variables for Adolfo's ADTs. }

{ NOTE
  Every identifier used by Adolfo is written in the
  English language for the following reasons:

  - English identifiers are almost always shorter.

  - It is easier to name procedures in English than
    in Spanish, because Spanish many times it is
    necessary to qualify the verbs used to name
    procedures and variables to avoid ambiguity. For
    example, the exact translation for DISPOSE() is
    Retorne_Memoria_Dinmica(), which is long, ugly,
    cumbersome, and very very long.

  - In general, in English technical ideas can be
    expressed using less words. As a token, compare
    this paragraphs with their Spanish translation.

  - In this times of globalization, English has become
    the oficial computing language, and this helps
    making all this work, including source code, more
    accesible to more people.

  - As high-tech literature is written in English, for 
    the reader it's easier to recognize English 
    acronyms. For example, OOP es the acronym for 
    Object Oriented Programming, which is what it's 
    written in most of the current literature.

}

{$M  32768,0,655360 } { Max Stack Low-heap High-heap }

{$IFDEF Learn_ADTs}  { definido para mis estudiantes }
  {$DEFINE Use_Full_Runtime_Checks }
{$ENDIF}

{$A+ Allign data on word boundary }
{$I- Enable IOResult error checks }
{$N+,E+ Allow for software 80x87 }
{$O- No overlays }
{$F- Don't force FAR calls }
{$V+ Strict string checking }

{$IFDEF    VER70 }
  {$G- No 286 extended instructions }
  {$X- No extended syntax }
  {$P- Disable open strings }
  {$T+ Type-checked pointers }
{$ENDIF}

{$IFDEF Learn_ADTs}
  {$DEFINE Use_Full_Runtime_Checks }
{$ENDIF}

{$IFDEF  Use_Full_Runtime_Checks}

  {$D+ Enable debug information }
  {$L+ Enable generation of local symbols }
  {$B+ Complete boolean evaluation }
  {$R+ Range checking on }
  {$S+ Stack checking on }

  {$IFDEF    VER70 }
    {$Q+ Integer overflow checking on }
    {$Y+ Enable ObjectBrowser Symbols }
  {$ENDIF}

{$ELSE}

  {$D- Disable debug information }
  {$L- Disable generation of local symbols }
  {$B- Short circuit boolean eval }
  {$R- Range checking off }
  {$S- Stack checking off }

  {$IFDEF    VER70 }
    {$Q- Integer overflow checking off }
    {$Y- Disable ObjectBrowser symbols }
  {$ENDIF}

{$ENDIF  Use_Full_Runtime_Checks}

{$DEFINE USE_Except}
{$UNDEF  USE_Except}

{$IFDEF OOP_Support} {$IFNDEF OOP_Support}
    Use_OBJECT:  The compiler supports OOP
    Use_PRIVATE: The compiler supports PRIVATE
    Use_PUBLIC:  The compiler supports PUBLIC
{$ENDIF}             {$ENDIF}

{$UNDEF  Use_OBJECT }
{$UNDEF  Use_PRIVATE }
{$UNDEF  Use_PUBLIC  }

{$IFDEF OOP_Support}
  {$IFDEF    VER40 }
    Error: You need a newer compiler to use OBJECTS.
  {$ENDIF}

  {$IFDEF    VER50 }
    Error: You need a newer compiler to use OBJECTS.
  {$ENDIF}
{$ENDIF}

{$IFDEF    VER55 }
  {$DEFINE Use_OBJECT  }
  {$UNDEF  Use_PRIVATE }
  {$UNDEF  Use_PUBLIC  }

{$ELSE} {$IFDEF    VER60 }
  {$DEFINE Use_OBJECT  }
  {$DEFINE Use_PRIVATE }
  {$UNDEF  Use_PUBLIC  }

{$ELSE}
  {$DEFINE Use_OBJECT  }
  {$DEFINE Use_PRIVATE }
  {$DEFINE Use_PUBLIC  }

{$ENDIF} {$ENDIF}

{ EOF: ADT-ADH.inc }
