// FILE: tools.cpp
/* RESULTADO
   Implementa herramientas utilitarias de programacin.  */
/* PROGRAMADORES
   Esteban Solis Quesada.
   Gustavo Sanabria Sanabria

   Universidad de Costa Rica                          	*/

#include "tools.hpp"
#include <dos.h>
#include <time.h>

char readkey()
/* RESULTADO
   Recibe una tecla o toma el primer caracter del buffer de teclado. */
{ /* readkey */
  char key;
  asm push ax;
  asm mov  ah, 08;
  asm int  21h;
  asm mov  key, al;
  asm pop  ax;
  return (key);
} /* readkey */

void clrkeybuf()
/* RESULTADO
   Limpia el buffer del teclado */
{  /* clrkeybuf */
  while(kbhit())
    readkey();
}  /* clrkeybuf */

void keydelay(int secdelay)
/* RESULTADO
   Espera hasta por secdelay segundos, o hasta que el usuario
   pulse alguno tecla.   DEPURADO: ADH-01/88
   Si sec > 59 entonces espera solo 59 segundos               */
/* MODIFICACIONES
   Adaptado para C++. EASQ                                    */
{  /* keydelay */

  unsigned int initsec, t1, nowsec;
  int          diff, stop;
  char         ch;
  struct time  inittime;

  gettime(&inittime);
  initsec = inittime.ti_sec;
  if (secdelay > 59) {
    secdelay = 59;
  }
  else if (secdelay < 0) {
    secdelay = 0;
  };
  stop = FALSE;
  diff = 0;
  clrkeybuf();
  while ((!stop) && (diff < secdelay)) {
    gettime(&inittime);
    nowsec = inittime.ti_sec;          /* segundos de la hora actual    */
    stop   = kbhit();                  /* salga al tocar una tecla      */
    t1     = nowsec;
    diff   = t1 - initsec;             /* tiempo que ya ha transcurrido */
    if (diff < 0) {
      diff = diff + 60; /* agregue 60 segundo cuando da vuelta la aguja */
    };
  };
  /* limpia el buffer de lectura */
  clrkeybuf();
} /* keydelay */

void play(
  notes note,
  int 	duration
)
/* RESULTADO
   Toca una nota durante un momento. */
{ // play
  float frecuency =522;
  for (notes loop = CF; loop <= note; loop++)
    frecuency *= 1.059463094;
  sound(frecuency);
  delay(duration);
  nosound();
} // play

void beep ()
/* RESULTADO
   Produce un 'beep' armonioso para el oido. */
{ // beep
  for (int i = 0; i < 2; i ++) {
    play(G,50);
    play(D,50);
  }
} // beep
